文章标题 POJ 3126 : Prime Path (BFS)

来源:互联网 发布:手机阿里云os登录 编辑:程序博客网 时间:2024/06/10 17:24

Prime Path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题意:给你两个四位数a,b,然后将a变成b,每次只能改变a中的一个位数,且改变完的这个四位数还是素数,问最少的次数能将a变为b。不能变为b就输出Impossible
分析:用bfs.可以先将1000~9999中的素数求出来,标记一下,当前出队的数位tmp,将tmp的四个位数每次改变一个位数上的数,如果是素数,切还未被访问过,则放进队列中,直到出队的是所求的值,就将到达次数所用的次数返回。
代码:

#include<iostream>#include<string>#include<cstdio>#include<cstring>#include<vector>#include<math.h>#include<map>#include<queue> #include<algorithm>using namespace std;const int inf = 0x3f3f3f3f;int a,b;int prime[10005];int vis[100005];//标记已经访问过 int  cnt;int judge_prime(int a){//判断a是否为素数     for (int i=2;i*i<=a;i++){        if (a%i==0)return 0;    }    return 1;}void init (){//初始化,如果是素数的话就标记为1     cnt=0;    memset (prime,0,sizeof (prime));    memset (vis,0,sizeof (vis));    for (int i=1001;i<=9999;i+=2){        if (judge_prime(i)==0)continue;        prime[i]=1;    }}struct node {    int a;    int cost;};int bfs(int a,int b){    memset (vis,0,sizeof (vis));    if (a==b){        return 0;    }    queue <node> q;    node tmp;    vis[a]=1;//标记    tmp.a=a;    tmp.cost=0;    q.push(tmp);    while (!q.empty()){        node t = q.front();q.pop();        if (t.a==b) return t.cost;//找到就返回         node tt;        for (int i=0;i<=9;i++){//个位数的情况             tt.a=t.a/10*10+i;            tt.cost=t.cost +1;            if (prime[tt.a]&&!vis[tt.a]){//如果是素数,且还未被访问过就进入队列                 q.push(tt);                vis[tt.a]=1;            }        }        for (int i=0;i<=9;i++){//十位数情况             int s=t.a%10;            tt.a=t.a/100*100+i*10+s;            tt.cost=t.cost +1;            if (prime[tt.a]&&!vis[tt.a]){                q.push(tt);                vis[tt.a]=1;            }        }        for (int i=0;i<=9;i++){//百位数情况             int s=t.a%100;            tt.a=t.a/1000*1000+i*100+s;            tt.cost=t.cost +1;            if (prime[tt.a]&&!vis[tt.a]){                q.push(tt);                vis[tt.a]=1;            }        }        for (int i=1;i<=9;i++){//千位数情况,千位数不能为0,i从1开始             int s=t.a%1000;            tt.a=t.a/10000+i*1000+s;            tt.cost=t.cost +1;            if (prime[tt.a]&&!vis[tt.a]){                q.push(tt);                vis[tt.a]=1;            }        }    }    return -1;//没有返回-1 }int main (){    int t;    init();    cin>>t;    while (t--){        cin>>a>>b;        int ans = bfs(a,b);        if (ans==-1) cout<<"Impossible"<<endl;        else cout<<ans<<endl;    }     return 0;}
0 0
原创粉丝点击